namespace ynhtm.DBUtility
{
    public interface IQuery
    {
        string EncodeString(string s);

        IQuery And();
        IQuery BracketBegin();
        IQuery BracketEnd();
        IQuery Equal(string name, object value);
        IQuery Gt(string name, object value);
        IQuery In(string name, object value);
        IQuery In<T>(string name, T[] values);
        IQuery Is(string name, object value);
        IQuery IsNot(string name, object value);
        IQuery Like(string name, string value);
        IQuery Lt(string name, object value);
        IQuery NotEqual(string name, object value);
        IQuery NotIn(string name, object value);
        IQuery NotIn<T>(string name, T[] values);
        IQuery NotLike(string name, string value);
        IQuery Or();
        IQuery Sql(string sql);

        string ToString();
    }
}